/* Indicator.c generated by valac 0.56.18, the Vala compiler
 * generated from Indicator.vala, do not modify */

/*-
 * Copyright (c) 2015 Wingpanel Developers (http://launchpad.net/wingpanel)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "keyboard.h"
#include <wingpanel.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <glib.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <gmodule.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	KEYBOARD_INDICATOR_0_PROPERTY,
	KEYBOARD_INDICATOR_SERVER_TYPE_PROPERTY,
	KEYBOARD_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* keyboard_indicator_properties[KEYBOARD_INDICATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _KeyboardIndicatorPrivate {
	WingpanelIndicatorManagerServerType _server_type;
	GdkKeymap* keymap;
	GSettings* settings;
	GtkBox* indicator_box;
	GtkBox* main_box;
	GtkRevealer* numlock_revealer;
	GtkRevealer* capslock_revealer;
	KeyboardWidgetsLayoutManager* layouts;
	KeyboardWidgetsKeyboardIcon* layouts_icon;
	GtkRevealer* layouts_revealer;
};

static gint KeyboardIndicator_private_offset;
static gpointer keyboard_indicator_parent_class = NULL;

static GtkWidget* keyboard_indicator_real_get_display_widget (WingpanelIndicator* base);
static void ___lambda15_ (KeyboardIndicator* self);
static void keyboard_indicator_update_visibility (KeyboardIndicator* self);
static void ____lambda15__g_settings_changed (GSettings* _sender,
                                       const gchar* key,
                                       gpointer self);
static void ___lambda16_ (KeyboardIndicator* self);
static void ____lambda16__gdk_keymap_state_changed (GdkKeymap* _sender,
                                             gpointer self);
static gboolean ___lambda17_ (KeyboardIndicator* self,
                       GdkEventButton* e);
static gboolean ____lambda17__gtk_widget_button_press_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self);
static void ___lambda18_ (KeyboardIndicator* self);
static void ____lambda18__keyboard_widgets_layout_manager_updated (KeyboardWidgetsLayoutManager* _sender,
                                                            gpointer self);
static void keyboard_indicator_update_tooltip (KeyboardIndicator* self);
static GtkWidget* keyboard_indicator_real_get_widget (WingpanelIndicator* base);
static void keyboard_indicator_show_settings (KeyboardIndicator* self);
static void _keyboard_indicator_show_settings_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self);
static void keyboard_indicator_show_keyboard_map (KeyboardIndicator* self);
static void _keyboard_indicator_show_keyboard_map_gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self);
static void keyboard_indicator_real_opened (WingpanelIndicator* base);
static void keyboard_indicator_real_closed (WingpanelIndicator* base);
static void keyboard_indicator_finalize (GObject * obj);
static GType keyboard_indicator_get_type_once (void);
static void _vala_keyboard_indicator_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_keyboard_indicator_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
keyboard_indicator_get_instance_private (KeyboardIndicator* self)
{
	return G_STRUCT_MEMBER_P (self, KeyboardIndicator_private_offset);
}

KeyboardIndicator*
keyboard_indicator_construct (GType object_type,
                              WingpanelIndicatorManagerServerType server_type)
{
	KeyboardIndicator * self = NULL;
#line 32 "../src/Indicator.vala"
	bindtextdomain (CONSTANTS_GETTEXT_PACKAGE, CONSTANTS_LOCALEDIR);
#line 33 "../src/Indicator.vala"
	bind_textdomain_codeset (CONSTANTS_GETTEXT_PACKAGE, "UTF-8");
#line 35 "../src/Indicator.vala"
	self = (KeyboardIndicator*) g_object_new (object_type, "code-name", WINGPANEL_INDICATOR_KEYBOARD, "server-type", server_type, NULL);
#line 31 "../src/Indicator.vala"
	return self;
#line 133 "Indicator.c"
}

KeyboardIndicator*
keyboard_indicator_new (WingpanelIndicatorManagerServerType server_type)
{
#line 31 "../src/Indicator.vala"
	return keyboard_indicator_construct (KEYBOARD_TYPE_INDICATOR, server_type);
#line 141 "Indicator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 74 "../src/Indicator.vala"
	return self ? g_object_ref (self) : NULL;
#line 149 "Indicator.c"
}

static void
___lambda15_ (KeyboardIndicator* self)
{
#line 77 "../src/Indicator.vala"
	keyboard_indicator_update_visibility (self);
#line 157 "Indicator.c"
}

static void
____lambda15__g_settings_changed (GSettings* _sender,
                                  const gchar* key,
                                  gpointer self)
{
#line 76 "../src/Indicator.vala"
	___lambda15_ ((KeyboardIndicator*) self);
#line 167 "Indicator.c"
}

static void
___lambda16_ (KeyboardIndicator* self)
{
#line 81 "../src/Indicator.vala"
	keyboard_indicator_update_visibility (self);
#line 175 "Indicator.c"
}

static void
____lambda16__gdk_keymap_state_changed (GdkKeymap* _sender,
                                        gpointer self)
{
#line 80 "../src/Indicator.vala"
	___lambda16_ ((KeyboardIndicator*) self);
#line 184 "Indicator.c"
}

static gboolean
___lambda17_ (KeyboardIndicator* self,
              GdkEventButton* e)
{
	gboolean result;
#line 84 "../src/Indicator.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 85 "../src/Indicator.vala"
	if (e->button == ((guint) GDK_BUTTON_MIDDLE)) {
#line 196 "Indicator.c"
		KeyboardWidgetsLayoutManager* _tmp0_;
#line 86 "../src/Indicator.vala"
		_tmp0_ = self->priv->layouts;
#line 86 "../src/Indicator.vala"
		keyboard_widgets_layout_manager_next (_tmp0_);
#line 87 "../src/Indicator.vala"
		result = GDK_EVENT_STOP;
#line 87 "../src/Indicator.vala"
		return result;
#line 206 "Indicator.c"
	}
#line 89 "../src/Indicator.vala"
	result = GDK_EVENT_PROPAGATE;
#line 89 "../src/Indicator.vala"
	return result;
#line 212 "Indicator.c"
}

static gboolean
____lambda17__gtk_widget_button_press_event (GtkWidget* _sender,
                                             GdkEventButton* event,
                                             gpointer self)
{
	gboolean result;
	result = ___lambda17_ ((KeyboardIndicator*) self, event);
#line 84 "../src/Indicator.vala"
	return result;
#line 224 "Indicator.c"
}

static void
___lambda18_ (KeyboardIndicator* self)
{
#line 94 "../src/Indicator.vala"
	keyboard_indicator_update_visibility (self);
#line 232 "Indicator.c"
}

static void
____lambda18__keyboard_widgets_layout_manager_updated (KeyboardWidgetsLayoutManager* _sender,
                                                       gpointer self)
{
#line 93 "../src/Indicator.vala"
	___lambda18_ ((KeyboardIndicator*) self);
#line 241 "Indicator.c"
}

static GtkWidget*
keyboard_indicator_real_get_display_widget (WingpanelIndicator* base)
{
	KeyboardIndicator * self;
	GtkBox* _tmp0_;
	GtkBox* _tmp36_;
	GtkWidget* _tmp37_;
	GtkWidget* result;
#line 41 "../src/Indicator.vala"
	self = (KeyboardIndicator*) base;
#line 42 "../src/Indicator.vala"
	_tmp0_ = self->priv->indicator_box;
#line 42 "../src/Indicator.vala"
	if (_tmp0_ == NULL) {
#line 258 "Indicator.c"
		GtkImage* numlock_icon = NULL;
		GtkImage* _tmp1_;
		gchar** _tmp2_;
		gchar** _tmp3_;
		gint _tmp3__length1;
		gchar* _tmp4_;
		GtkRevealer* _tmp5_ = NULL;
		GtkRevealer* _tmp6_;
		GtkImage* _tmp7_;
		GtkImage* capslock_icon = NULL;
		GtkImage* _tmp8_;
		gchar** _tmp9_;
		gchar** _tmp10_;
		gint _tmp10__length1;
		gchar* _tmp11_;
		GtkRevealer* _tmp12_ = NULL;
		GtkRevealer* _tmp13_;
		GtkImage* _tmp14_;
		KeyboardWidgetsKeyboardIcon* _tmp15_;
		GtkRevealer* _tmp16_ = NULL;
		GtkRevealer* _tmp17_;
		KeyboardWidgetsKeyboardIcon* _tmp18_;
		GtkBox* _tmp19_ = NULL;
		GtkBox* _tmp20_;
		GtkRevealer* _tmp21_;
		GtkBox* _tmp22_;
		GtkRevealer* _tmp23_;
		GtkBox* _tmp24_;
		GtkRevealer* _tmp25_;
		GSettings* _tmp26_;
		GdkDisplay* _tmp27_;
		GdkKeymap* _tmp28_;
		GdkKeymap* _tmp29_;
		GSettings* _tmp30_;
		GdkKeymap* _tmp31_;
		GtkBox* _tmp32_;
		KeyboardWidgetsLayoutManager* _tmp33_;
		KeyboardWidgetsLayoutManager* _tmp34_;
		KeyboardWidgetsLayoutManager* _tmp35_;
#line 43 "../src/Indicator.vala"
		_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("input-keyboard-numlock-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 43 "../src/Indicator.vala"
		g_object_ref_sink (_tmp1_);
#line 43 "../src/Indicator.vala"
		numlock_icon = _tmp1_;
#line 45 "../src/Indicator.vala"
		_tmp2_ = g_new0 (gchar*, 0 + 1);
#line 45 "../src/Indicator.vala"
		_tmp3_ = _tmp2_;
#line 45 "../src/Indicator.vala"
		_tmp3__length1 = 0;
#line 45 "../src/Indicator.vala"
		_tmp4_ = granite_markup_accel_tooltip (_tmp3_, (gint) 0, _ ("Num Lock is on"));
#line 45 "../src/Indicator.vala"
		_tmp5_ = (GtkRevealer*) gtk_revealer_new ();
#line 45 "../src/Indicator.vala"
		gtk_revealer_set_transition_type (_tmp5_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT);
#line 45 "../src/Indicator.vala"
		gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp5_, _tmp4_);
#line 45 "../src/Indicator.vala"
		_g_free0 (_tmp4_);
#line 45 "../src/Indicator.vala"
		g_object_ref_sink (_tmp5_);
#line 45 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->numlock_revealer);
#line 45 "../src/Indicator.vala"
		self->priv->numlock_revealer = _tmp5_;
#line 45 "../src/Indicator.vala"
		_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 49 "../src/Indicator.vala"
		_tmp6_ = self->priv->numlock_revealer;
#line 49 "../src/Indicator.vala"
		_tmp7_ = numlock_icon;
#line 49 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
#line 51 "../src/Indicator.vala"
		_tmp8_ = (GtkImage*) gtk_image_new_from_icon_name ("input-keyboard-capslock-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 51 "../src/Indicator.vala"
		g_object_ref_sink (_tmp8_);
#line 51 "../src/Indicator.vala"
		capslock_icon = _tmp8_;
#line 53 "../src/Indicator.vala"
		_tmp9_ = g_new0 (gchar*, 0 + 1);
#line 53 "../src/Indicator.vala"
		_tmp10_ = _tmp9_;
#line 53 "../src/Indicator.vala"
		_tmp10__length1 = 0;
#line 53 "../src/Indicator.vala"
		_tmp11_ = granite_markup_accel_tooltip (_tmp10_, (gint) 0, _ ("Caps Lock is on"));
#line 53 "../src/Indicator.vala"
		_tmp12_ = (GtkRevealer*) gtk_revealer_new ();
#line 53 "../src/Indicator.vala"
		gtk_revealer_set_transition_type (_tmp12_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT);
#line 53 "../src/Indicator.vala"
		gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp12_, _tmp11_);
#line 53 "../src/Indicator.vala"
		_g_free0 (_tmp11_);
#line 53 "../src/Indicator.vala"
		g_object_ref_sink (_tmp12_);
#line 53 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->capslock_revealer);
#line 53 "../src/Indicator.vala"
		self->priv->capslock_revealer = _tmp12_;
#line 53 "../src/Indicator.vala"
		_tmp10_ = (_vala_array_free (_tmp10_, _tmp10__length1, (GDestroyNotify) g_free), NULL);
#line 57 "../src/Indicator.vala"
		_tmp13_ = self->priv->capslock_revealer;
#line 57 "../src/Indicator.vala"
		_tmp14_ = capslock_icon;
#line 57 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
#line 59 "../src/Indicator.vala"
		_tmp15_ = keyboard_widgets_keyboard_icon_new ();
#line 59 "../src/Indicator.vala"
		g_object_ref_sink (_tmp15_);
#line 59 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->layouts_icon);
#line 59 "../src/Indicator.vala"
		self->priv->layouts_icon = _tmp15_;
#line 61 "../src/Indicator.vala"
		_tmp16_ = (GtkRevealer*) gtk_revealer_new ();
#line 61 "../src/Indicator.vala"
		gtk_revealer_set_transition_type (_tmp16_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT);
#line 61 "../src/Indicator.vala"
		g_object_ref_sink (_tmp16_);
#line 61 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->layouts_revealer);
#line 61 "../src/Indicator.vala"
		self->priv->layouts_revealer = _tmp16_;
#line 64 "../src/Indicator.vala"
		_tmp17_ = self->priv->layouts_revealer;
#line 64 "../src/Indicator.vala"
		_tmp18_ = self->priv->layouts_icon;
#line 64 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
#line 66 "../src/Indicator.vala"
		_tmp19_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 66 "../src/Indicator.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp19_, GTK_ALIGN_CENTER);
#line 66 "../src/Indicator.vala"
		g_object_ref_sink (_tmp19_);
#line 66 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->indicator_box);
#line 66 "../src/Indicator.vala"
		self->priv->indicator_box = _tmp19_;
#line 69 "../src/Indicator.vala"
		_tmp20_ = self->priv->indicator_box;
#line 69 "../src/Indicator.vala"
		_tmp21_ = self->priv->numlock_revealer;
#line 69 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
#line 70 "../src/Indicator.vala"
		_tmp22_ = self->priv->indicator_box;
#line 70 "../src/Indicator.vala"
		_tmp23_ = self->priv->capslock_revealer;
#line 70 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
#line 71 "../src/Indicator.vala"
		_tmp24_ = self->priv->indicator_box;
#line 71 "../src/Indicator.vala"
		_tmp25_ = self->priv->layouts_revealer;
#line 71 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
#line 73 "../src/Indicator.vala"
		_tmp26_ = g_settings_new ("io.elementary.wingpanel.keyboard");
#line 73 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->settings);
#line 73 "../src/Indicator.vala"
		self->priv->settings = _tmp26_;
#line 74 "../src/Indicator.vala"
		_tmp27_ = gdk_display_get_default ();
#line 74 "../src/Indicator.vala"
		_tmp28_ = gdk_keymap_get_for_display (_tmp27_);
#line 74 "../src/Indicator.vala"
		_tmp29_ = _g_object_ref0 (_tmp28_);
#line 74 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->keymap);
#line 74 "../src/Indicator.vala"
		self->priv->keymap = _tmp29_;
#line 76 "../src/Indicator.vala"
		_tmp30_ = self->priv->settings;
#line 76 "../src/Indicator.vala"
		g_signal_connect_object (_tmp30_, "changed", (GCallback) ____lambda15__g_settings_changed, self, 0);
#line 80 "../src/Indicator.vala"
		_tmp31_ = self->priv->keymap;
#line 80 "../src/Indicator.vala"
		g_signal_connect_object (_tmp31_, "state-changed", (GCallback) ____lambda16__gdk_keymap_state_changed, self, 0);
#line 84 "../src/Indicator.vala"
		_tmp32_ = self->priv->indicator_box;
#line 84 "../src/Indicator.vala"
		g_signal_connect_object ((GtkWidget*) _tmp32_, "button-press-event", (GCallback) ____lambda17__gtk_widget_button_press_event, self, 0);
#line 92 "../src/Indicator.vala"
		_tmp33_ = keyboard_widgets_layout_manager_new ();
#line 92 "../src/Indicator.vala"
		g_object_ref_sink (_tmp33_);
#line 92 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->layouts);
#line 92 "../src/Indicator.vala"
		self->priv->layouts = _tmp33_;
#line 93 "../src/Indicator.vala"
		_tmp34_ = self->priv->layouts;
#line 93 "../src/Indicator.vala"
		g_signal_connect_object (_tmp34_, "updated", (GCallback) ____lambda18__keyboard_widgets_layout_manager_updated, self, 0);
#line 97 "../src/Indicator.vala"
		_tmp35_ = self->priv->layouts;
#line 97 "../src/Indicator.vala"
		g_signal_emit_by_name (_tmp35_, "updated");
#line 42 "../src/Indicator.vala"
		_g_object_unref0 (capslock_icon);
#line 42 "../src/Indicator.vala"
		_g_object_unref0 (numlock_icon);
#line 470 "Indicator.c"
	}
#line 100 "../src/Indicator.vala"
	_tmp36_ = self->priv->indicator_box;
#line 100 "../src/Indicator.vala"
	_tmp37_ = _g_object_ref0 ((GtkWidget*) _tmp36_);
#line 100 "../src/Indicator.vala"
	result = _tmp37_;
#line 100 "../src/Indicator.vala"
	return result;
#line 480 "Indicator.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 507 "Indicator.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 513 "Indicator.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 519 "Indicator.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 523 "Indicator.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 531 "Indicator.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 535 "Indicator.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 547 "Indicator.c"
}

static void
keyboard_indicator_update_visibility (KeyboardIndicator* self)
{
	KeyboardWidgetsKeyboardIcon* _tmp0_;
	KeyboardWidgetsLayoutManager* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	KeyboardWidgetsLayoutManager* _tmp7_;
	GtkRevealer* _tmp9_;
	gboolean _tmp10_ = FALSE;
	GdkKeymap* _tmp11_;
	GtkRevealer* _tmp13_;
	gboolean _tmp14_ = FALSE;
	GdkKeymap* _tmp15_;
	GtkRevealer* _tmp17_;
	gboolean _tmp18_ = FALSE;
	GtkRevealer* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp31_ = FALSE;
	GtkRevealer* _tmp32_;
	gboolean _tmp33_;
	gboolean _tmp34_;
	gboolean _tmp40_ = FALSE;
	gboolean _tmp41_ = FALSE;
	GtkRevealer* _tmp42_;
	gboolean _tmp43_;
	gboolean _tmp44_;
#line 103 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 104 "../src/Indicator.vala"
	_tmp0_ = self->priv->layouts_icon;
#line 104 "../src/Indicator.vala"
	_tmp1_ = self->priv->layouts;
#line 104 "../src/Indicator.vala"
	_tmp2_ = keyboard_widgets_layout_manager_get_current_language_code (_tmp1_);
#line 104 "../src/Indicator.vala"
	_tmp3_ = _tmp2_;
#line 104 "../src/Indicator.vala"
	_tmp4_ = string_slice (_tmp3_, (glong) 0, (glong) 2);
#line 104 "../src/Indicator.vala"
	_tmp5_ = _tmp4_;
#line 104 "../src/Indicator.vala"
	gtk_label_set_label ((GtkLabel*) _tmp0_, _tmp5_);
#line 104 "../src/Indicator.vala"
	_g_free0 (_tmp5_);
#line 105 "../src/Indicator.vala"
	_tmp7_ = self->priv->layouts;
#line 105 "../src/Indicator.vala"
	if (keyboard_widgets_layout_manager_has_multiple_layouts (_tmp7_)) {
#line 105 "../src/Indicator.vala"
		_tmp6_ = TRUE;
#line 605 "Indicator.c"
	} else {
		GSettings* _tmp8_;
#line 105 "../src/Indicator.vala"
		_tmp8_ = self->priv->settings;
#line 105 "../src/Indicator.vala"
		_tmp6_ = g_settings_get_boolean (_tmp8_, "always-show-layout");
#line 612 "Indicator.c"
	}
#line 105 "../src/Indicator.vala"
	_tmp9_ = self->priv->layouts_revealer;
#line 105 "../src/Indicator.vala"
	gtk_revealer_set_reveal_child (_tmp9_, _tmp6_);
#line 107 "../src/Indicator.vala"
	_tmp11_ = self->priv->keymap;
#line 107 "../src/Indicator.vala"
	if (gdk_keymap_get_num_lock_state (_tmp11_)) {
#line 622 "Indicator.c"
		GSettings* _tmp12_;
#line 107 "../src/Indicator.vala"
		_tmp12_ = self->priv->settings;
#line 107 "../src/Indicator.vala"
		_tmp10_ = g_settings_get_boolean (_tmp12_, "numlock");
#line 628 "Indicator.c"
	} else {
#line 107 "../src/Indicator.vala"
		_tmp10_ = FALSE;
#line 632 "Indicator.c"
	}
#line 107 "../src/Indicator.vala"
	_tmp13_ = self->priv->numlock_revealer;
#line 107 "../src/Indicator.vala"
	gtk_revealer_set_reveal_child (_tmp13_, _tmp10_);
#line 108 "../src/Indicator.vala"
	_tmp15_ = self->priv->keymap;
#line 108 "../src/Indicator.vala"
	if (gdk_keymap_get_caps_lock_state (_tmp15_)) {
#line 642 "Indicator.c"
		GSettings* _tmp16_;
#line 108 "../src/Indicator.vala"
		_tmp16_ = self->priv->settings;
#line 108 "../src/Indicator.vala"
		_tmp14_ = g_settings_get_boolean (_tmp16_, "capslock");
#line 648 "Indicator.c"
	} else {
#line 108 "../src/Indicator.vala"
		_tmp14_ = FALSE;
#line 652 "Indicator.c"
	}
#line 108 "../src/Indicator.vala"
	_tmp17_ = self->priv->capslock_revealer;
#line 108 "../src/Indicator.vala"
	gtk_revealer_set_reveal_child (_tmp17_, _tmp14_);
#line 110 "../src/Indicator.vala"
	_tmp19_ = self->priv->numlock_revealer;
#line 110 "../src/Indicator.vala"
	_tmp20_ = gtk_revealer_get_reveal_child (_tmp19_);
#line 110 "../src/Indicator.vala"
	_tmp21_ = _tmp20_;
#line 110 "../src/Indicator.vala"
	if (_tmp21_) {
#line 666 "Indicator.c"
		gboolean _tmp22_ = FALSE;
		GtkRevealer* _tmp23_;
		gboolean _tmp24_;
		gboolean _tmp25_;
#line 110 "../src/Indicator.vala"
		_tmp23_ = self->priv->layouts_revealer;
#line 110 "../src/Indicator.vala"
		_tmp24_ = gtk_revealer_get_reveal_child (_tmp23_);
#line 110 "../src/Indicator.vala"
		_tmp25_ = _tmp24_;
#line 110 "../src/Indicator.vala"
		if (_tmp25_) {
#line 110 "../src/Indicator.vala"
			_tmp22_ = TRUE;
#line 681 "Indicator.c"
		} else {
			GtkRevealer* _tmp26_;
			gboolean _tmp27_;
			gboolean _tmp28_;
#line 110 "../src/Indicator.vala"
			_tmp26_ = self->priv->capslock_revealer;
#line 110 "../src/Indicator.vala"
			_tmp27_ = gtk_revealer_get_reveal_child (_tmp26_);
#line 110 "../src/Indicator.vala"
			_tmp28_ = _tmp27_;
#line 110 "../src/Indicator.vala"
			_tmp22_ = _tmp28_;
#line 694 "Indicator.c"
		}
#line 110 "../src/Indicator.vala"
		_tmp18_ = _tmp22_;
#line 698 "Indicator.c"
	} else {
#line 110 "../src/Indicator.vala"
		_tmp18_ = FALSE;
#line 702 "Indicator.c"
	}
#line 110 "../src/Indicator.vala"
	if (_tmp18_) {
#line 706 "Indicator.c"
		GtkRevealer* _tmp29_;
#line 111 "../src/Indicator.vala"
		_tmp29_ = self->priv->numlock_revealer;
#line 111 "../src/Indicator.vala"
		gtk_widget_set_margin_end ((GtkWidget*) _tmp29_, 6);
#line 712 "Indicator.c"
	} else {
		GtkRevealer* _tmp30_;
#line 113 "../src/Indicator.vala"
		_tmp30_ = self->priv->numlock_revealer;
#line 113 "../src/Indicator.vala"
		gtk_widget_set_margin_end ((GtkWidget*) _tmp30_, 0);
#line 719 "Indicator.c"
	}
#line 116 "../src/Indicator.vala"
	_tmp32_ = self->priv->capslock_revealer;
#line 116 "../src/Indicator.vala"
	_tmp33_ = gtk_revealer_get_reveal_child (_tmp32_);
#line 116 "../src/Indicator.vala"
	_tmp34_ = _tmp33_;
#line 116 "../src/Indicator.vala"
	if (_tmp34_) {
#line 729 "Indicator.c"
		GtkRevealer* _tmp35_;
		gboolean _tmp36_;
		gboolean _tmp37_;
#line 116 "../src/Indicator.vala"
		_tmp35_ = self->priv->layouts_revealer;
#line 116 "../src/Indicator.vala"
		_tmp36_ = gtk_revealer_get_reveal_child (_tmp35_);
#line 116 "../src/Indicator.vala"
		_tmp37_ = _tmp36_;
#line 116 "../src/Indicator.vala"
		_tmp31_ = _tmp37_;
#line 741 "Indicator.c"
	} else {
#line 116 "../src/Indicator.vala"
		_tmp31_ = FALSE;
#line 745 "Indicator.c"
	}
#line 116 "../src/Indicator.vala"
	if (_tmp31_) {
#line 749 "Indicator.c"
		GtkRevealer* _tmp38_;
#line 117 "../src/Indicator.vala"
		_tmp38_ = self->priv->capslock_revealer;
#line 117 "../src/Indicator.vala"
		gtk_widget_set_margin_end ((GtkWidget*) _tmp38_, 6);
#line 755 "Indicator.c"
	} else {
		GtkRevealer* _tmp39_;
#line 119 "../src/Indicator.vala"
		_tmp39_ = self->priv->capslock_revealer;
#line 119 "../src/Indicator.vala"
		gtk_widget_set_margin_end ((GtkWidget*) _tmp39_, 0);
#line 762 "Indicator.c"
	}
#line 122 "../src/Indicator.vala"
	_tmp42_ = self->priv->layouts_revealer;
#line 122 "../src/Indicator.vala"
	_tmp43_ = gtk_revealer_get_reveal_child (_tmp42_);
#line 122 "../src/Indicator.vala"
	_tmp44_ = _tmp43_;
#line 122 "../src/Indicator.vala"
	if (_tmp44_) {
#line 122 "../src/Indicator.vala"
		_tmp41_ = TRUE;
#line 774 "Indicator.c"
	} else {
		GtkRevealer* _tmp45_;
		gboolean _tmp46_;
		gboolean _tmp47_;
#line 122 "../src/Indicator.vala"
		_tmp45_ = self->priv->numlock_revealer;
#line 122 "../src/Indicator.vala"
		_tmp46_ = gtk_revealer_get_reveal_child (_tmp45_);
#line 122 "../src/Indicator.vala"
		_tmp47_ = _tmp46_;
#line 122 "../src/Indicator.vala"
		_tmp41_ = _tmp47_;
#line 787 "Indicator.c"
	}
#line 122 "../src/Indicator.vala"
	if (_tmp41_) {
#line 122 "../src/Indicator.vala"
		_tmp40_ = TRUE;
#line 793 "Indicator.c"
	} else {
		GtkRevealer* _tmp48_;
		gboolean _tmp49_;
		gboolean _tmp50_;
#line 122 "../src/Indicator.vala"
		_tmp48_ = self->priv->capslock_revealer;
#line 122 "../src/Indicator.vala"
		_tmp49_ = gtk_revealer_get_reveal_child (_tmp48_);
#line 122 "../src/Indicator.vala"
		_tmp50_ = _tmp49_;
#line 122 "../src/Indicator.vala"
		_tmp40_ = _tmp50_;
#line 806 "Indicator.c"
	}
#line 122 "../src/Indicator.vala"
	wingpanel_indicator_set_visible ((WingpanelIndicator*) self, _tmp40_);
#line 123 "../src/Indicator.vala"
	keyboard_indicator_update_tooltip (self);
#line 812 "Indicator.c"
}

static void
_keyboard_indicator_show_settings_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self)
{
#line 146 "../src/Indicator.vala"
	keyboard_indicator_show_settings ((KeyboardIndicator*) self);
#line 821 "Indicator.c"
}

static void
_keyboard_indicator_show_keyboard_map_gtk_button_clicked (GtkButton* _sender,
                                                          gpointer self)
{
#line 153 "../src/Indicator.vala"
	keyboard_indicator_show_keyboard_map ((KeyboardIndicator*) self);
#line 830 "Indicator.c"
}

static GtkWidget*
keyboard_indicator_real_get_widget (WingpanelIndicator* base)
{
	KeyboardIndicator * self;
	GtkBox* _tmp0_;
	GtkBox* _tmp19_;
	GtkWidget* _tmp20_;
	GtkWidget* result;
#line 126 "../src/Indicator.vala"
	self = (KeyboardIndicator*) base;
#line 127 "../src/Indicator.vala"
	_tmp0_ = self->priv->main_box;
#line 127 "../src/Indicator.vala"
	if (_tmp0_ == NULL) {
#line 847 "Indicator.c"
		GtkSeparator* separator = NULL;
		GtkSeparator* _tmp1_ = NULL;
		GtkModelButton* map_button = NULL;
		gchar* _tmp2_;
		GtkModelButton* _tmp3_ = NULL;
		GtkBox* _tmp4_;
		GtkBox* _tmp5_;
		KeyboardWidgetsLayoutManager* _tmp6_;
		GtkBox* _tmp7_;
		GtkSeparator* _tmp8_;
		GtkBox* _tmp9_;
		GtkModelButton* _tmp10_;
		WingpanelIndicatorManagerServerType _tmp11_;
		GtkBox* _tmp17_;
		GtkModelButton* _tmp18_;
#line 128 "../src/Indicator.vala"
		_tmp1_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 128 "../src/Indicator.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp1_, 3);
#line 128 "../src/Indicator.vala"
		gtk_widget_set_margin_bottom ((GtkWidget*) _tmp1_, 3);
#line 128 "../src/Indicator.vala"
		g_object_ref_sink (_tmp1_);
#line 128 "../src/Indicator.vala"
		separator = _tmp1_;
#line 133 "../src/Indicator.vala"
		_tmp2_ = g_strdup (_ ("Show Keyboard Layout"));
#line 133 "../src/Indicator.vala"
		_tmp3_ = (GtkModelButton*) gtk_model_button_new ();
#line 133 "../src/Indicator.vala"
		g_object_set (_tmp3_, "text", _tmp2_, NULL);
#line 133 "../src/Indicator.vala"
		_g_free0 (_tmp2_);
#line 133 "../src/Indicator.vala"
		g_object_ref_sink (_tmp3_);
#line 133 "../src/Indicator.vala"
		map_button = _tmp3_;
#line 137 "../src/Indicator.vala"
		_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 137 "../src/Indicator.vala"
		g_object_ref_sink (_tmp4_);
#line 137 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->main_box);
#line 137 "../src/Indicator.vala"
		self->priv->main_box = _tmp4_;
#line 138 "../src/Indicator.vala"
		_tmp5_ = self->priv->main_box;
#line 138 "../src/Indicator.vala"
		_tmp6_ = self->priv->layouts;
#line 138 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
#line 139 "../src/Indicator.vala"
		_tmp7_ = self->priv->main_box;
#line 139 "../src/Indicator.vala"
		_tmp8_ = separator;
#line 139 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp8_);
#line 140 "../src/Indicator.vala"
		_tmp9_ = self->priv->main_box;
#line 140 "../src/Indicator.vala"
		_tmp10_ = map_button;
#line 140 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp10_);
#line 142 "../src/Indicator.vala"
		_tmp11_ = self->priv->_server_type;
#line 142 "../src/Indicator.vala"
		if (_tmp11_ != WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_GREETER) {
#line 915 "Indicator.c"
			GtkModelButton* settings_button = NULL;
			gchar* _tmp12_;
			GtkModelButton* _tmp13_ = NULL;
			GtkModelButton* _tmp14_;
			GtkBox* _tmp15_;
			GtkModelButton* _tmp16_;
#line 143 "../src/Indicator.vala"
			_tmp12_ = g_strdup (_ ("Keyboard Settings…"));
#line 143 "../src/Indicator.vala"
			_tmp13_ = (GtkModelButton*) gtk_model_button_new ();
#line 143 "../src/Indicator.vala"
			g_object_set (_tmp13_, "text", _tmp12_, NULL);
#line 143 "../src/Indicator.vala"
			_g_free0 (_tmp12_);
#line 143 "../src/Indicator.vala"
			g_object_ref_sink (_tmp13_);
#line 143 "../src/Indicator.vala"
			settings_button = _tmp13_;
#line 146 "../src/Indicator.vala"
			_tmp14_ = settings_button;
#line 146 "../src/Indicator.vala"
			g_signal_connect_object ((GtkButton*) _tmp14_, "clicked", (GCallback) _keyboard_indicator_show_settings_gtk_button_clicked, self, 0);
#line 148 "../src/Indicator.vala"
			_tmp15_ = self->priv->main_box;
#line 148 "../src/Indicator.vala"
			_tmp16_ = settings_button;
#line 148 "../src/Indicator.vala"
			gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
#line 142 "../src/Indicator.vala"
			_g_object_unref0 (settings_button);
#line 946 "Indicator.c"
		}
#line 151 "../src/Indicator.vala"
		_tmp17_ = self->priv->main_box;
#line 151 "../src/Indicator.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp17_);
#line 153 "../src/Indicator.vala"
		_tmp18_ = map_button;
#line 153 "../src/Indicator.vala"
		g_signal_connect_object ((GtkButton*) _tmp18_, "clicked", (GCallback) _keyboard_indicator_show_keyboard_map_gtk_button_clicked, self, 0);
#line 127 "../src/Indicator.vala"
		_g_object_unref0 (map_button);
#line 127 "../src/Indicator.vala"
		_g_object_unref0 (separator);
#line 960 "Indicator.c"
	}
#line 156 "../src/Indicator.vala"
	_tmp19_ = self->priv->main_box;
#line 156 "../src/Indicator.vala"
	_tmp20_ = _g_object_ref0 ((GtkWidget*) _tmp19_);
#line 156 "../src/Indicator.vala"
	result = _tmp20_;
#line 156 "../src/Indicator.vala"
	return result;
#line 970 "Indicator.c"
}

static void
keyboard_indicator_real_opened (WingpanelIndicator* base)
{
	KeyboardIndicator * self;
#line 159 "../src/Indicator.vala"
	self = (KeyboardIndicator*) base;
#line 979 "Indicator.c"
}

static void
keyboard_indicator_real_closed (WingpanelIndicator* base)
{
	KeyboardIndicator * self;
#line 163 "../src/Indicator.vala"
	self = (KeyboardIndicator*) base;
#line 988 "Indicator.c"
}

static void
keyboard_indicator_show_settings (KeyboardIndicator* self)
{
	GError* _inner_error0_ = NULL;
#line 167 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/Indicator.vala"
	g_signal_emit_by_name ((WingpanelIndicator*) self, "close");
#line 999 "Indicator.c"
	{
#line 171 "../src/Indicator.vala"
		g_app_info_launch_default_for_uri ("settings://input/keyboard/layout", NULL, &_inner_error0_);
#line 171 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1005 "Indicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 170 "../src/Indicator.vala"
		e = _inner_error0_;
#line 170 "../src/Indicator.vala"
		_inner_error0_ = NULL;
#line 173 "../src/Indicator.vala"
		_tmp0_ = e;
#line 173 "../src/Indicator.vala"
		_tmp1_ = _tmp0_->message;
#line 173 "../src/Indicator.vala"
		g_warning ("Indicator.vala:173: %s", _tmp1_);
#line 170 "../src/Indicator.vala"
		_g_error_free0 (e);
#line 1027 "Indicator.c"
	}
	__finally0:
#line 170 "../src/Indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 170 "../src/Indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 170 "../src/Indicator.vala"
		g_clear_error (&_inner_error0_);
#line 170 "../src/Indicator.vala"
		return;
#line 1038 "Indicator.c"
	}
}

static void
keyboard_indicator_show_keyboard_map (KeyboardIndicator* self)
{
	gchar* command = NULL;
	KeyboardWidgetsLayoutManager* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 177 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 178 "../src/Indicator.vala"
	g_signal_emit_by_name ((WingpanelIndicator*) self, "close");
#line 180 "../src/Indicator.vala"
	_tmp0_ = self->priv->layouts;
#line 180 "../src/Indicator.vala"
	_tmp1_ = keyboard_widgets_layout_manager_get_current_with_variant (_tmp0_);
#line 180 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 180 "../src/Indicator.vala"
	_tmp3_ = g_strconcat ("gkbd-keyboard-display \"--layout=", _tmp2_, NULL);
#line 180 "../src/Indicator.vala"
	_tmp4_ = _tmp3_;
#line 180 "../src/Indicator.vala"
	_tmp5_ = g_strconcat (_tmp4_, "\"", NULL);
#line 180 "../src/Indicator.vala"
	_tmp6_ = _tmp5_;
#line 180 "../src/Indicator.vala"
	_g_free0 (_tmp4_);
#line 180 "../src/Indicator.vala"
	_g_free0 (_tmp2_);
#line 180 "../src/Indicator.vala"
	command = _tmp6_;
#line 1078 "Indicator.c"
	{
		GAppInfo* _tmp7_ = NULL;
		const gchar* _tmp8_;
		GAppInfo* _tmp9_;
#line 183 "../src/Indicator.vala"
		_tmp8_ = command;
#line 183 "../src/Indicator.vala"
		_tmp9_ = g_app_info_create_from_commandline (_tmp8_, NULL, G_APP_INFO_CREATE_NONE, &_inner_error0_);
#line 183 "../src/Indicator.vala"
		_tmp7_ = _tmp9_;
#line 183 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1091 "Indicator.c"
			goto __catch0_g_error;
		}
#line 183 "../src/Indicator.vala"
		g_app_info_launch (_tmp7_, NULL, NULL, &_inner_error0_);
#line 183 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 183 "../src/Indicator.vala"
			_g_object_unref0 (_tmp7_);
#line 1100 "Indicator.c"
			goto __catch0_g_error;
		}
#line 182 "../src/Indicator.vala"
		_g_object_unref0 (_tmp7_);
#line 1105 "Indicator.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 182 "../src/Indicator.vala"
		e = _inner_error0_;
#line 182 "../src/Indicator.vala"
		_inner_error0_ = NULL;
#line 185 "../src/Indicator.vala"
		_tmp10_ = e;
#line 185 "../src/Indicator.vala"
		_tmp11_ = _tmp10_->message;
#line 185 "../src/Indicator.vala"
		g_warning ("Indicator.vala:185: Error launching keyboard layout display: %s", _tmp11_);
#line 182 "../src/Indicator.vala"
		_g_error_free0 (e);
#line 1125 "Indicator.c"
	}
	__finally0:
#line 182 "../src/Indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 182 "../src/Indicator.vala"
		_g_free0 (command);
#line 182 "../src/Indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 182 "../src/Indicator.vala"
		g_clear_error (&_inner_error0_);
#line 182 "../src/Indicator.vala"
		return;
#line 1138 "Indicator.c"
	}
#line 177 "../src/Indicator.vala"
	_g_free0 (command);
#line 1142 "Indicator.c"
}

static void
keyboard_indicator_update_tooltip (KeyboardIndicator* self)
{
	gchar* description = NULL;
	KeyboardWidgetsLayoutManager* _tmp0_;
	gchar* _tmp1_;
	gchar* accel_label = NULL;
	gchar* _tmp2_;
	GtkRevealer* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 189 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/Indicator.vala"
	_tmp0_ = self->priv->layouts;
#line 190 "../src/Indicator.vala"
	_tmp1_ = keyboard_widgets_layout_manager_get_current_description (_tmp0_);
#line 190 "../src/Indicator.vala"
	description = _tmp1_;
#line 191 "../src/Indicator.vala"
	_tmp2_ = g_strdup_printf (GRANITE_TOOLTIP_SECONDARY_TEXT_MARKUP, _ ("Middle-click to switch to the next layout"));
#line 191 "../src/Indicator.vala"
	accel_label = _tmp2_;
#line 193 "../src/Indicator.vala"
	_tmp3_ = self->priv->layouts_revealer;
#line 193 "../src/Indicator.vala"
	_tmp4_ = g_strdup_printf ("%s\n%s", description, accel_label);
#line 193 "../src/Indicator.vala"
	_tmp5_ = _tmp4_;
#line 193 "../src/Indicator.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp3_, _tmp5_);
#line 193 "../src/Indicator.vala"
	_g_free0 (_tmp5_);
#line 189 "../src/Indicator.vala"
	_g_free0 (accel_label);
#line 189 "../src/Indicator.vala"
	_g_free0 (description);
#line 1182 "Indicator.c"
}

WingpanelIndicatorManagerServerType
keyboard_indicator_get_server_type (KeyboardIndicator* self)
{
	WingpanelIndicatorManagerServerType result;
#line 19 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 19 "../src/Indicator.vala"
	result = self->priv->_server_type;
#line 19 "../src/Indicator.vala"
	return result;
#line 1195 "Indicator.c"
}

static void
keyboard_indicator_set_server_type (KeyboardIndicator* self,
                                    WingpanelIndicatorManagerServerType value)
{
	WingpanelIndicatorManagerServerType old_value;
#line 19 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/Indicator.vala"
	old_value = keyboard_indicator_get_server_type (self);
#line 19 "../src/Indicator.vala"
	if (old_value != value) {
#line 19 "../src/Indicator.vala"
		self->priv->_server_type = value;
#line 19 "../src/Indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, keyboard_indicator_properties[KEYBOARD_INDICATOR_SERVER_TYPE_PROPERTY]);
#line 1213 "Indicator.c"
	}
}

static void
keyboard_indicator_class_init (KeyboardIndicatorClass * klass,
                               gpointer klass_data)
{
#line 18 "../src/Indicator.vala"
	keyboard_indicator_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/Indicator.vala"
	g_type_class_adjust_private_offset (klass, &KeyboardIndicator_private_offset);
#line 18 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->get_display_widget = (GtkWidget* (*) (WingpanelIndicator*)) keyboard_indicator_real_get_display_widget;
#line 18 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->get_widget = (GtkWidget* (*) (WingpanelIndicator*)) keyboard_indicator_real_get_widget;
#line 18 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->opened = (void (*) (WingpanelIndicator*)) keyboard_indicator_real_opened;
#line 18 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->closed = (void (*) (WingpanelIndicator*)) keyboard_indicator_real_closed;
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_keyboard_indicator_get_property;
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_keyboard_indicator_set_property;
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->finalize = keyboard_indicator_finalize;
#line 18 "../src/Indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KEYBOARD_INDICATOR_SERVER_TYPE_PROPERTY, keyboard_indicator_properties[KEYBOARD_INDICATOR_SERVER_TYPE_PROPERTY] = g_param_spec_enum ("server-type", "server-type", "server-type", WINGPANEL_INDICATOR_MANAGER_TYPE_SERVER_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1241 "Indicator.c"
}

static void
keyboard_indicator_instance_init (KeyboardIndicator * self,
                                  gpointer klass)
{
#line 18 "../src/Indicator.vala"
	self->priv = keyboard_indicator_get_instance_private (self);
#line 1250 "Indicator.c"
}

static void
keyboard_indicator_finalize (GObject * obj)
{
	KeyboardIndicator * self;
#line 18 "../src/Indicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KEYBOARD_TYPE_INDICATOR, KeyboardIndicator);
#line 21 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->keymap);
#line 22 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->settings);
#line 23 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->indicator_box);
#line 24 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->main_box);
#line 25 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->numlock_revealer);
#line 26 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->capslock_revealer);
#line 27 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->layouts);
#line 28 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->layouts_icon);
#line 29 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->layouts_revealer);
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (keyboard_indicator_parent_class)->finalize (obj);
#line 1279 "Indicator.c"
}

static GType
keyboard_indicator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KeyboardIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) keyboard_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KeyboardIndicator), 0, (GInstanceInitFunc) keyboard_indicator_instance_init, NULL };
	GType keyboard_indicator_type_id;
	keyboard_indicator_type_id = g_type_register_static (WINGPANEL_TYPE_INDICATOR, "KeyboardIndicator", &g_define_type_info, 0);
	KeyboardIndicator_private_offset = g_type_add_instance_private (keyboard_indicator_type_id, sizeof (KeyboardIndicatorPrivate));
	return keyboard_indicator_type_id;
}

GType
keyboard_indicator_get_type (void)
{
	static volatile gsize keyboard_indicator_type_id__once = 0;
	if (g_once_init_enter (&keyboard_indicator_type_id__once)) {
		GType keyboard_indicator_type_id;
		keyboard_indicator_type_id = keyboard_indicator_get_type_once ();
		g_once_init_leave (&keyboard_indicator_type_id__once, keyboard_indicator_type_id);
	}
	return keyboard_indicator_type_id__once;
}

static void
_vala_keyboard_indicator_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	KeyboardIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KEYBOARD_TYPE_INDICATOR, KeyboardIndicator);
#line 18 "../src/Indicator.vala"
	switch (property_id) {
#line 18 "../src/Indicator.vala"
		case KEYBOARD_INDICATOR_SERVER_TYPE_PROPERTY:
#line 18 "../src/Indicator.vala"
		g_value_set_enum (value, keyboard_indicator_get_server_type (self));
#line 18 "../src/Indicator.vala"
		break;
#line 1320 "Indicator.c"
		default:
#line 18 "../src/Indicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Indicator.vala"
		break;
#line 1326 "Indicator.c"
	}
}

static void
_vala_keyboard_indicator_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	KeyboardIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KEYBOARD_TYPE_INDICATOR, KeyboardIndicator);
#line 18 "../src/Indicator.vala"
	switch (property_id) {
#line 18 "../src/Indicator.vala"
		case KEYBOARD_INDICATOR_SERVER_TYPE_PROPERTY:
#line 18 "../src/Indicator.vala"
		keyboard_indicator_set_server_type (self, g_value_get_enum (value));
#line 18 "../src/Indicator.vala"
		break;
#line 1346 "Indicator.c"
		default:
#line 18 "../src/Indicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Indicator.vala"
		break;
#line 1352 "Indicator.c"
	}
}

WingpanelIndicator*
get_indicator (GModule* module,
               WingpanelIndicatorManagerServerType server_type)
{
	KeyboardIndicator* indicator = NULL;
	KeyboardIndicator* _tmp0_;
	WingpanelIndicator* result;
#line 197 "../src/Indicator.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 198 "../src/Indicator.vala"
	g_debug ("Indicator.vala:198: Activating Keyboard Indicator");
#line 199 "../src/Indicator.vala"
	_tmp0_ = keyboard_indicator_new (server_type);
#line 199 "../src/Indicator.vala"
	indicator = _tmp0_;
#line 200 "../src/Indicator.vala"
	result = (WingpanelIndicator*) indicator;
#line 200 "../src/Indicator.vala"
	return result;
#line 1375 "Indicator.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

